#include "sgg/graphics.h"
#include "brush_utils.h" // περιέχει την getBrushByName
#include <iostream>

// Μέγεθος παραθύρου
const float WINDOW_WIDTH = 800;
const float WINDOW_HEIGHT = 600;

/**
 * Η συνάρτηση `drawExamples` χρησιμοποιεί τη `getBrushByName`
 * για να δημιουργήσει αντικείμενα `Brush` με διαφορετικά χρώματα
 * και να τα εφαρμόσει σε βασικά σχήματα για να δείξει τη λειτουργικότητα της συνάρτησης.
 */
void drawExamples() {
    // Χρησιμοποιούμε διάφορα χρώματα μέσω της getBrushByName
    graphics::Brush redBrush = brush_utils::getBrushByName("red"); // Δημιουργία κόκκινου Brush
    graphics::Brush greenBrush = brush_utils::getBrushByName("green"); // Δημιουργία πράσινου Brush
    graphics::Brush blueBrush = brush_utils::getBrushByName("blue"); // Δημιουργία μπλε Brush
    graphics::Brush yellowBrush = brush_utils::getBrushByName("yellow"); // Δημιουργία κίτρινου Brush
    graphics::Brush unknownBrush = brush_utils::getBrushByName("unknown"); // Ανύπαρκτο χρώμα (επιστρέφει μαύρο)

    // Σχεδιάζουμε ένα κύκλο με κόκκινο χρώμα
    graphics::drawDisk(200, 150, 50, redBrush);

    // Σχεδιάζουμε ένα ορθογώνιο με πράσινο χρώμα
    graphics::drawRect(400, 150, 100, 50, greenBrush);

    // Σχεδιάζουμε ένα τετράγωνο με μπλε χρώμα
    graphics::drawRect(600, 150, 50, 50, blueBrush);

    // Σχεδιάζουμε έναν δίσκο με κίτρινο χρώμα
    graphics::drawDisk(300, 350, 40, yellowBrush);

    // Σχεδιάζουμε έναν κύκλο με μαύρο χρώμα (άγνωστο όνομα)
    graphics::drawDisk(500, 350, 40, unknownBrush);

    // Κείμενο που εξηγεί την χρήση του μαύρου Brush για άγνωστο χρώμα
    graphics::setFont("bin/assets/Roboto_Bold.ttf");
    graphics::drawText(400, 450, 20, "Unknown color defaults to black", unknownBrush);
}

int main() {
    // Δημιουργία παραθύρου
    graphics::createWindow(WINDOW_WIDTH, WINDOW_HEIGHT, "getBrushByName() Example");

    // Ρύθμιση συνάρτησης σχεδίασης
    graphics::setDrawFunction(drawExamples);

    // Έναρξη κύκλου μηνυμάτων
    graphics::startMessageLoop();

    return 0;
}